-- Fake Item Links by Jadya EU-Well of Eternity

local addonName, addonTable = ...

local mf, edt, resultLink, left_tooltip, right_tooltip
local C, DD -- constants and dropdowns

local function init_constants()
 DD = {
  ["Quality"] = {},
  ["Properties"] = {},
  ["Itemlevel"] = {},
  ["Stats"] = {},
 }

 C = {}
 
 C["Quality"] = {
  ["Rare (+10 Ilvl)"] = 171,
  ["Epic"] = 657,
 }

 C["Properties"] = {
  ["Pristine / Craft"]  = 2,
  ["Cooking Ingr."]     = 498,
  ["Raid Finder (-12)"] = 451,
  ["Heroic (+13)"]      = 449,
  ["Heroic (+15)"]      = 566,
  ["Mythic (+26)"]      = 450,
  ["Mythic (+30)"]      = 567,
  ["Warforged (+6)"]    = 571,
  ["Empowered (+45)"]   = 648,
  ["TWarped (660)"]     = 615,
  ["TWarped WF (675)"]  = 645,
  ["Timewalker (600)"]  = 602,
  ["Stage 1/6"]         = 525,
  ["Stage 2/6 (+15)"]   = 526,
  ["Stage 3/6 (+30)"]   = 527,
  ["Stage 4/6 (+45)"]   = 593,
  ["Stage 5/6 (+60)"]   = 617,
  ["Stage 6/6 (+75)"]   = 618,
 }

 C["Itemlevel"] = {
  ["-100"]= 518,
  ["-80"] = 519,
  ["-60"] = 520,
  ["-30"] = 521,
  ["-15"] = 522,
  ["+3"]  = 622,
  ["+6"]  = 623,
  ["+9"]  = 624,
  ["+12"] = 625,
  ["+15"] = 626,
  ["+18"] = 627,
  ["+21"] = 628,
  ["+24"] = 629,
  ["+27"] = 630,
  ["+30"] = 631,
  ["+33"] = 632,
  ["+36"] = 633,
  ["+39"] = 634,
  ["+42"] = 635,
  ["+45"] = 636,
  ["+48"] = 637,
  ["+51"] = 638,
  ["+54"] = 639,
  ["+57"] = 640,
  ["+60"] = 641,
  ["+70"] = 557,
 }

 C["Stats"] = {
  [" Avoidance"] = 40,
  [" Leech"] = 41,
  [" Speed"] = 42,
  [" Indestructible"] = 43,
  [" Prismatic Socket"] = 608,

  ["of the Savage"] = 66,
  ["of the Quickblade"] = 87,
  ["of the Feverflare"] = 108,
  ["of the Deft"] = 130,
  ["of the Aurora"] = 150,
  ["of the Merciless"] = 175,
  ["of the Harmonious"] = 196,
  ["of the Strategist"] = 217,
  ["of the Guileful"] = 238,
  ["of the Windshaper"] = 259,
  ["of the Noble"] = 280,
  ["of the Stormbreaker"] = 301,
  ["of the Stalwart"] = 322,
  ["of the Fanatic"] = 343,
  ["of the Zealot"] = 364,
  ["of the Diviner"] = 385,
  ["of the Herald"] = 406,
  ["of the Augur"] = 427,
  ["of the Decimator"] = 486,
  ["of the Impatient"] = 487,
  ["of the Savant"] = 488,
  ["of the Relentless"] = 489,
  ["of the Adaptable"] = 490,
  ["of the Unbreakable"] = 491,
  ["of the Pious"] = 492,
 }
end

local function updateLeftTooltip()
 local itemID = tonumber(edt:GetText())
 
 if not itemID then return end
 
 local _, link = GetItemInfo(edt:GetText())
 
 if not link then 
  left_tooltip:Hide()
  right_tooltip:Hide()
  return
 end

 left_tooltip:SetOwner(mf, "ANCHOR_NONE")
 left_tooltip:SetPoint("RIGHT", mf, "LEFT")
 left_tooltip:ClearLines()
 left_tooltip:SetHyperlink(link)
 left_tooltip:Show()
end

local function updateRightTooltip()
 if not resultLink then 
  right_tooltip:Hide()
  return
 end
 
 right_tooltip:SetOwner(mf, "ANCHOR_NONE")
 right_tooltip:SetPoint("LEFT", mf, "RIGHT")
 right_tooltip:ClearLines()
 right_tooltip:SetHyperlink(resultLink)
 right_tooltip:Show()
end

local function generateLink()
 local itemID = tonumber(edt:GetText())
 
 if not itemID then return end
 
 local name, link, quality, _, _, _, _, _, equipSlot, texture = GetItemInfo(itemID)
 
 if not link then return end -- the item doesn't exist
 
 local _, _, _, col = GetItemQualityColor(quality or 0)

 local numBonus = 0
 local s_bonus = ""
 local function addBonus(dd)
  local text = UIDropDownMenu_GetText(dd)
  local bonuses = C[dd.group]
  if bonuses[text] then
   numBonus = numBonus + 1
   local bonus = bonuses[text]
   s_bonus = s_bonus..":"..bonus
  end
 end
 for _,v in pairs(DD) do
  for _,dropdown in pairs(v) do
   addBonus(dropdown)
  end
 end
 
 local _, _, _, baseILvl = GetItemInfo(itemID)

 resultLink = "|c"..col.."|Hitem:"..itemID..":0:0:0:0:0:0:0:100:268:0:3:"..numBonus..s_bonus.."|h["..(name or "").."]|h|r"
 
 local _,_,_,ILvl = GetItemInfo(resultLink)
 if ILvl < 1 then
  print(addonName.." - Itemlevel cannot be a negative number")
  return
 end
 
 updateRightTooltip()
 return true
end

local function init_dropdown(self)
 local info = UIDropDownMenu_CreateInfo()
 info.notCheckable = true

 local function foreachinorder(t,f)
  local keys = {}
  for k,_ in pairs(t) do
    keys[#keys+1] = k
  end
  if self.group == "Itemlevel" then
   table.sort(keys,function (a,b) return tonumber(a) < tonumber(b) end)
  else
   table.sort(keys,function (a,b) return string.lower(a) < string.lower(b) end)
  end
  for _,k in ipairs(keys) do
   f(k,t[k])
  end
 end
 
 local function onClick(f)
  if not resultLink then return end

  local oldText = UIDropDownMenu_GetText(self)
  UIDropDownMenu_SetText(self, f:GetText())
  if not generateLink() then
   UIDropDownMenu_SetText(self, oldText)
  end
 end
 
 info.func = onClick
 info.text = self.group == "Itemlevel" and 0 or EMPTY
 UIDropDownMenu_AddButton(info, level)
 info.disabled = true
 info.text = "-"
 UIDropDownMenu_AddButton(info, level)
 
 foreachinorder(C[self.group], function(key)
  local found = false
  if self.disable then
   for _,v in pairs(DD[self.group]) do
    if v ~= self and UIDropDownMenu_GetText(v) == key then
     found = true
     break
    end
   end
  else
   found = false
  end
  
  info.disabled = found
  info.text = key
  UIDropDownMenu_AddButton(info, level)
 end)
end

local function initDropDowns()

 local w
 local base_text
 local disable

 local function createDropDown(i, t, ...)
  local f = CreateFrame("Button", "FakeItemLinksDD"..i, mf, "UIDropDownMenuTemplate")
  _G["FakeItemLinksDD"..i.."Left"]:SetTexture("Interface\\Glues\\Common\\Glues-EditBox-Background")
  _G["FakeItemLinksDD"..i.."Middle"]:SetTexture("Interface\\Glues\\Common\\Glues-EditBox-Background")
  _G["FakeItemLinksDD"..i.."Right"]:SetTexture("Interface\\Glues\\Common\\Glues-EditBox-Background")
  local btn = _G["FakeItemLinksDD"..i.."Button"]
  btn:ClearAllPoints()
  btn:SetPoint("LEFT", f, "RIGHT", -55, -5)
  btn:SetNormalTexture("Interface\\Buttons\\Arrow-Down-Up")
  btn:SetPushedTexture("Interface\\Buttons\\Arrow-Down-Down")
  local text = _G["FakeItemLinksDD"..i.."Text"]
  text:ClearAllPoints()
  text:SetPoint("LEFT", f, "LEFT", 40, 0)
  text:SetJustifyH("LEFT")
  local tab = DD[t]
  if #tab > 0 then
   f:SetPoint("TOP", tab[#tab], "BOTTOM", 0, -2)
  else
   mf["lbl_"..t] = mf:CreateFontString()
   local txt = mf["lbl_"..t]
   txt:SetPoint("BOTTOMLEFT", f, "TOPLEFT", 10, 3)
   txt:SetFont("Fonts\\ARIALN.ttf", 14, "")
   txt:SetText(t)
   f:SetPoint(...)
  end
  table.insert(tab, f)
  f.group = t
  f.disable = disable
  UIDropDownMenu_SetWidth(f, w)
  UIDropDownMenu_SetText(f, base_text)
  UIDropDownMenu_Initialize(f, init_dropdown)
 end
 
 base_text = EMPTY
 w = 150
 disable = true
 
 createDropDown(1, "Quality", "TOPLEFT", mf, "TOPLEFT", 5, -100)
 
 for i = 2,5 do
  createDropDown(i, "Properties", "TOP", DD["Quality"][1], "BOTTOM", 0, -20)
 end
 
 for i = 6,9 do
  createDropDown(i, "Stats", "TOP", DD["Properties"][4], "BOTTOM", 0, -20)
 end
 
 base_text = 0
 w = 75
 disable = false
 
 for i = 10,15 do
  createDropDown(i, "Itemlevel", "TOPRIGHT", mf, "TOPRIGHT", -5, -100)
 end
end

local function resetDropDowns()
 local base_text = EMPTY
 
 UIDropDownMenu_SetText(DD["Quality"][1], base_text)
 
 for _,v in pairs(DD["Properties"]) do
  UIDropDownMenu_SetText(v, base_text)
 end
 
 for _,v in pairs(DD["Stats"]) do
  UIDropDownMenu_SetText(v, base_text)
 end
 
 base_text = 0
 
 for _,v in pairs(DD["Itemlevel"]) do
  UIDropDownMenu_SetText(v, base_text)
 end
 
 generateLink()
end

local function initialize()
 if not mf then
  init_constants()
  
  mf = CreateFrame("Frame", nil, UIParent)
  mf:SetMovable(true)
  mf:EnableMouse(true)
  mf:RegisterForDrag("LeftButton")
  mf:SetScript("OnDragStart", function(self) self:StartMoving() end)
  mf:SetScript("OnDragStop",  function(self) self:StopMovingOrSizing() end)
  mf:SetPoint("CENTER")
  mf:SetSize(350,500)
  mf.tex = mf:CreateTexture()
  mf.tex:SetAllPoints()
  mf.tex:SetTexture(0,0,0,1)
  
  mf.title = mf:CreateFontString()
  mf.title:SetFont("Fonts\\ARIALN.ttf", 16, "")
  mf.title:SetPoint("TOP", mf, "TOP", 0, -10)
  mf.title:SetText("|cff0078fcFake ItemLinks|r")

  left_tooltip = CreateFrame("GameTooltip", "FakeItemLinksLeftTooltip", mf, "GameTooltipTemplate")
  left_tooltip:SetFrameStrata("MEDIUM")
  left_tooltip:SetOwner(mf, "ANCHOR_NONE")
  left_tooltip:SetPoint("RIGHT", mf, "LEFT")

  right_tooltip = CreateFrame("GameTooltip", "FakeItemLinksRightTooltip", mf, "GameTooltipTemplate")
  right_tooltip:SetFrameStrata("MEDIUM")
  right_tooltip:SetOwner(mf, "ANCHOR_NONE")
  right_tooltip:SetPoint("LEFT", mf, "RIGHT")
  
  edt = CreateFrame("EditBox", "FLEditbox", mf)
  edt:SetPoint("TOPLEFT", mf, "TOPLEFT", 15, -45)
  edt.lbl = edt:CreateFontString()
  edt.lbl:SetFont("Fonts\\ARIALN.ttf", 14, "")
  edt.lbl:SetText("Item")
  edt.lbl:SetPoint("BOTTOMLEFT", edt, "TOPLEFT", 0, 0) 
  edt:SetFontObject("GameFontHighlight")
  edt:SetWidth(100)
  edt:SetHeight(25)
  edt:SetBackdrop(GameTooltip:GetBackdrop())
  edt:SetBackdropColor(0, 0, 0, 0.8)
  edt:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
  edt:SetTextInsets(10, 0, 0, 0)
  edt:SetAutoFocus(false)
  local f = function(self) 
   self:ClearFocus()
   updateLeftTooltip()
   generateLink()
  end
  edt:SetScript("OnEnterPressed", f)
  edt:SetScript("OnEscapePressed", f)
  edt:ClearFocus()
  f = function(self) 
   local t, itemID = GetCursorInfo()
   if t == "item" then
    self:SetText(itemID)
	updateLeftTooltip()
	generateLink()
   end
  end

  edt:SetScript("OnMouseUp", f)
  edt:SetScript("OnReceiveDrag", f)
  
  edt.desc = edt:CreateFontString()
  edt.desc:SetFont("Fonts\\ARIALN.ttf", 12)
  edt.desc:SetPoint("LEFT", edt, "RIGHT", 10, 0)
  edt.desc:SetText("<-- Type an ItemID, link an Item or \ndrag an Item here")
  
  initDropDowns()
  
  local btn = CreateFrame("Button", nil, mf, "UIPanelButtonTemplate")
  btn:SetPoint("BOTTOMRIGHT", mf, "BOTTOMRIGHT", -15, 15)
  btn:SetWidth(100)
  btn:SetText(CLOSE)
  btn:SetScript("OnClick", function() mf:Hide() end)
  
  btn = CreateFrame("Button", nil, mf, "UIPanelButtonTemplate")
  btn:SetPoint("BOTTOMLEFT", mf, "BOTTOMLEFT", 15, 15)
  btn:SetWidth(100)
  btn:SetText("Chat Link")
  btn:SetScript("OnClick", function() 
   if resultLink then
    print(addonName.." - "..resultLink)
   end
  end)
  
  btn = CreateFrame("Button", nil, mf, "UIPanelButtonTemplate")
  btn:SetPoint("BOTTOM", mf, "BOTTOM", 0, 15)
  btn:SetWidth(100)
  btn:SetText(RESET)
  btn:SetScript("OnClick", resetDropDowns)
  
  local eventhandler = CreateFrame("Frame")
  eventhandler:RegisterEvent("GET_ITEM_INFO_RECEIVED")
  eventhandler:SetScript("OnEvent", function(self, event, ...)
   if mf and mf:IsVisible() then
    updateLeftTooltip()
    generateLink()
   end
  end)

  local function setItemID(link)
   if IsShiftKeyDown() and mf:IsVisible() and edt:HasFocus() then
    local _, itemID = strsplit(":", link)
    edt:SetText(itemID or "")
	updateLeftTooltip()
	generateLink()
	edt:ClearFocus()
   end
  end
  
  hooksecurefunc("HandleModifiedItemClick", setItemID)
  hooksecurefunc("SetItemRef", setItemID)
  
  mf:Show()
 else
  if not mf:IsVisible() then 
   updateLeftTooltip()
   generateLink()
   mf:Show()
  else
   mf:Hide()
  end
 end
end

-- slash command
SLASH_FAKEITEMLINKS1 = "/fakeitemlinks"
SLASH_FAKEITEMLINKS2 = "/fil"
SlashCmdList["FAKEITEMLINKS"] = initialize